// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from clober_msgs:msg/ControllerState.idl
// generated code does not contain a copyright notice
#include "clober_msgs/msg/detail/controller_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `fault_flags`
#include "rosidl_runtime_c/string_functions.h"

bool
clober_msgs__msg__ControllerState__init(clober_msgs__msg__ControllerState * msg)
{
  if (!msg) {
    return false;
  }
  // battery_voltage
  // charging_voltage
  // current_12v
  // current_24v
  // temperature
  // fault_flags
  if (!rosidl_runtime_c__String__Sequence__init(&msg->fault_flags, 0)) {
    clober_msgs__msg__ControllerState__fini(msg);
    return false;
  }
  // emergency_stop
  return true;
}

void
clober_msgs__msg__ControllerState__fini(clober_msgs__msg__ControllerState * msg)
{
  if (!msg) {
    return;
  }
  // battery_voltage
  // charging_voltage
  // current_12v
  // current_24v
  // temperature
  // fault_flags
  rosidl_runtime_c__String__Sequence__fini(&msg->fault_flags);
  // emergency_stop
}

bool
clober_msgs__msg__ControllerState__are_equal(const clober_msgs__msg__ControllerState * lhs, const clober_msgs__msg__ControllerState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // battery_voltage
  if (lhs->battery_voltage != rhs->battery_voltage) {
    return false;
  }
  // charging_voltage
  if (lhs->charging_voltage != rhs->charging_voltage) {
    return false;
  }
  // current_12v
  if (lhs->current_12v != rhs->current_12v) {
    return false;
  }
  // current_24v
  if (lhs->current_24v != rhs->current_24v) {
    return false;
  }
  // temperature
  if (lhs->temperature != rhs->temperature) {
    return false;
  }
  // fault_flags
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->fault_flags), &(rhs->fault_flags)))
  {
    return false;
  }
  // emergency_stop
  if (lhs->emergency_stop != rhs->emergency_stop) {
    return false;
  }
  return true;
}

bool
clober_msgs__msg__ControllerState__copy(
  const clober_msgs__msg__ControllerState * input,
  clober_msgs__msg__ControllerState * output)
{
  if (!input || !output) {
    return false;
  }
  // battery_voltage
  output->battery_voltage = input->battery_voltage;
  // charging_voltage
  output->charging_voltage = input->charging_voltage;
  // current_12v
  output->current_12v = input->current_12v;
  // current_24v
  output->current_24v = input->current_24v;
  // temperature
  output->temperature = input->temperature;
  // fault_flags
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->fault_flags), &(output->fault_flags)))
  {
    return false;
  }
  // emergency_stop
  output->emergency_stop = input->emergency_stop;
  return true;
}

clober_msgs__msg__ControllerState *
clober_msgs__msg__ControllerState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__ControllerState * msg = (clober_msgs__msg__ControllerState *)allocator.allocate(sizeof(clober_msgs__msg__ControllerState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(clober_msgs__msg__ControllerState));
  bool success = clober_msgs__msg__ControllerState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
clober_msgs__msg__ControllerState__destroy(clober_msgs__msg__ControllerState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    clober_msgs__msg__ControllerState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
clober_msgs__msg__ControllerState__Sequence__init(clober_msgs__msg__ControllerState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__ControllerState * data = NULL;

  if (size) {
    data = (clober_msgs__msg__ControllerState *)allocator.zero_allocate(size, sizeof(clober_msgs__msg__ControllerState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = clober_msgs__msg__ControllerState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        clober_msgs__msg__ControllerState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
clober_msgs__msg__ControllerState__Sequence__fini(clober_msgs__msg__ControllerState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      clober_msgs__msg__ControllerState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

clober_msgs__msg__ControllerState__Sequence *
clober_msgs__msg__ControllerState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__ControllerState__Sequence * array = (clober_msgs__msg__ControllerState__Sequence *)allocator.allocate(sizeof(clober_msgs__msg__ControllerState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = clober_msgs__msg__ControllerState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
clober_msgs__msg__ControllerState__Sequence__destroy(clober_msgs__msg__ControllerState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    clober_msgs__msg__ControllerState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
clober_msgs__msg__ControllerState__Sequence__are_equal(const clober_msgs__msg__ControllerState__Sequence * lhs, const clober_msgs__msg__ControllerState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!clober_msgs__msg__ControllerState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
clober_msgs__msg__ControllerState__Sequence__copy(
  const clober_msgs__msg__ControllerState__Sequence * input,
  clober_msgs__msg__ControllerState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(clober_msgs__msg__ControllerState);
    clober_msgs__msg__ControllerState * data =
      (clober_msgs__msg__ControllerState *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!clober_msgs__msg__ControllerState__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          clober_msgs__msg__ControllerState__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!clober_msgs__msg__ControllerState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
