// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from clober_msgs:msg/Feedback.idl
// generated code does not contain a copyright notice
#include "clober_msgs/msg/detail/feedback__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `controller_state`
#include "clober_msgs/msg/detail/controller_state__functions.h"
// Member `left_motor`
// Member `right_motor`
#include "clober_msgs/msg/detail/motor_state__functions.h"

bool
clober_msgs__msg__Feedback__init(clober_msgs__msg__Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  // controller_state
  if (!clober_msgs__msg__ControllerState__init(&msg->controller_state)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  // left_motor
  if (!clober_msgs__msg__MotorState__init(&msg->left_motor)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  // right_motor
  if (!clober_msgs__msg__MotorState__init(&msg->right_motor)) {
    clober_msgs__msg__Feedback__fini(msg);
    return false;
  }
  return true;
}

void
clober_msgs__msg__Feedback__fini(clober_msgs__msg__Feedback * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // controller_state
  clober_msgs__msg__ControllerState__fini(&msg->controller_state);
  // left_motor
  clober_msgs__msg__MotorState__fini(&msg->left_motor);
  // right_motor
  clober_msgs__msg__MotorState__fini(&msg->right_motor);
}

bool
clober_msgs__msg__Feedback__are_equal(const clober_msgs__msg__Feedback * lhs, const clober_msgs__msg__Feedback * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // controller_state
  if (!clober_msgs__msg__ControllerState__are_equal(
      &(lhs->controller_state), &(rhs->controller_state)))
  {
    return false;
  }
  // left_motor
  if (!clober_msgs__msg__MotorState__are_equal(
      &(lhs->left_motor), &(rhs->left_motor)))
  {
    return false;
  }
  // right_motor
  if (!clober_msgs__msg__MotorState__are_equal(
      &(lhs->right_motor), &(rhs->right_motor)))
  {
    return false;
  }
  return true;
}

bool
clober_msgs__msg__Feedback__copy(
  const clober_msgs__msg__Feedback * input,
  clober_msgs__msg__Feedback * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // controller_state
  if (!clober_msgs__msg__ControllerState__copy(
      &(input->controller_state), &(output->controller_state)))
  {
    return false;
  }
  // left_motor
  if (!clober_msgs__msg__MotorState__copy(
      &(input->left_motor), &(output->left_motor)))
  {
    return false;
  }
  // right_motor
  if (!clober_msgs__msg__MotorState__copy(
      &(input->right_motor), &(output->right_motor)))
  {
    return false;
  }
  return true;
}

clober_msgs__msg__Feedback *
clober_msgs__msg__Feedback__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__Feedback * msg = (clober_msgs__msg__Feedback *)allocator.allocate(sizeof(clober_msgs__msg__Feedback), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(clober_msgs__msg__Feedback));
  bool success = clober_msgs__msg__Feedback__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
clober_msgs__msg__Feedback__destroy(clober_msgs__msg__Feedback * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    clober_msgs__msg__Feedback__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
clober_msgs__msg__Feedback__Sequence__init(clober_msgs__msg__Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__Feedback * data = NULL;

  if (size) {
    data = (clober_msgs__msg__Feedback *)allocator.zero_allocate(size, sizeof(clober_msgs__msg__Feedback), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = clober_msgs__msg__Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        clober_msgs__msg__Feedback__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
clober_msgs__msg__Feedback__Sequence__fini(clober_msgs__msg__Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      clober_msgs__msg__Feedback__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

clober_msgs__msg__Feedback__Sequence *
clober_msgs__msg__Feedback__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__Feedback__Sequence * array = (clober_msgs__msg__Feedback__Sequence *)allocator.allocate(sizeof(clober_msgs__msg__Feedback__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = clober_msgs__msg__Feedback__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
clober_msgs__msg__Feedback__Sequence__destroy(clober_msgs__msg__Feedback__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    clober_msgs__msg__Feedback__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
clober_msgs__msg__Feedback__Sequence__are_equal(const clober_msgs__msg__Feedback__Sequence * lhs, const clober_msgs__msg__Feedback__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!clober_msgs__msg__Feedback__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
clober_msgs__msg__Feedback__Sequence__copy(
  const clober_msgs__msg__Feedback__Sequence * input,
  clober_msgs__msg__Feedback__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(clober_msgs__msg__Feedback);
    clober_msgs__msg__Feedback * data =
      (clober_msgs__msg__Feedback *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!clober_msgs__msg__Feedback__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          clober_msgs__msg__Feedback__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!clober_msgs__msg__Feedback__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
