// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from clober_msgs:msg/Feedback.idl
// generated code does not contain a copyright notice

#ifndef CLOBER_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_HPP_
#define CLOBER_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'controller_state'
#include "clober_msgs/msg/detail/controller_state__struct.hpp"
// Member 'left_motor'
// Member 'right_motor'
#include "clober_msgs/msg/detail/motor_state__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__clober_msgs__msg__Feedback __attribute__((deprecated))
#else
# define DEPRECATED__clober_msgs__msg__Feedback __declspec(deprecated)
#endif

namespace clober_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Feedback_
{
  using Type = Feedback_<ContainerAllocator>;

  explicit Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    controller_state(_init),
    left_motor(_init),
    right_motor(_init)
  {
    (void)_init;
  }

  explicit Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    controller_state(_alloc, _init),
    left_motor(_alloc, _init),
    right_motor(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _controller_state_type =
    clober_msgs::msg::ControllerState_<ContainerAllocator>;
  _controller_state_type controller_state;
  using _left_motor_type =
    clober_msgs::msg::MotorState_<ContainerAllocator>;
  _left_motor_type left_motor;
  using _right_motor_type =
    clober_msgs::msg::MotorState_<ContainerAllocator>;
  _right_motor_type right_motor;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__controller_state(
    const clober_msgs::msg::ControllerState_<ContainerAllocator> & _arg)
  {
    this->controller_state = _arg;
    return *this;
  }
  Type & set__left_motor(
    const clober_msgs::msg::MotorState_<ContainerAllocator> & _arg)
  {
    this->left_motor = _arg;
    return *this;
  }
  Type & set__right_motor(
    const clober_msgs::msg::MotorState_<ContainerAllocator> & _arg)
  {
    this->right_motor = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    clober_msgs::msg::Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const clober_msgs::msg::Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<clober_msgs::msg::Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<clober_msgs::msg::Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      clober_msgs::msg::Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<clober_msgs::msg::Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      clober_msgs::msg::Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<clober_msgs::msg::Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<clober_msgs::msg::Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<clober_msgs::msg::Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__clober_msgs__msg__Feedback
    std::shared_ptr<clober_msgs::msg::Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__clober_msgs__msg__Feedback
    std::shared_ptr<clober_msgs::msg::Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Feedback_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->controller_state != other.controller_state) {
      return false;
    }
    if (this->left_motor != other.left_motor) {
      return false;
    }
    if (this->right_motor != other.right_motor) {
      return false;
    }
    return true;
  }
  bool operator!=(const Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Feedback_

// alias to use template instance with default allocator
using Feedback =
  clober_msgs::msg::Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace clober_msgs

#endif  // CLOBER_MSGS__MSG__DETAIL__FEEDBACK__STRUCT_HPP_
